import java.io.*;

class Condition
{
	int type;	//see constants below
	int check;	//always = 0x10 (for internal use)
	int amount;	//of objects, difficult level
	int resource;	//resource type (see constants below)
	int unit_object;
	int unit_location;
	int unit_type;
	int player;
	int technology;	//see "Complete Constant Lists" in AOKH utilities
	int timer;
	int cond_unknown;
	POINT area_ll;
	POINT area_ur;
	int unit_group;	//see constants below
	int building_type;	//Civilian, Military, Building, Other
	int ai_signal;

	//Constants
	final String strtype[] = { "whoknows", "Bring Object to Area", "Bring Object to Object", "Own Objects", "Own Fewer Objects",
		"Objects in Area", "Destroy Object", "Capture Object", "Accumulate Attribute", "Research Tehcnology", "Timer",
		"Object Selected", "AI Signal", "Player Defeated", "Object Has Target", "Object Visible", "Object Not Visible",
		"Researching Technology", "Units Garrisoned", "Difficulty Level", "Own Fewer Foundations", "Selected Objects in Area",
		"Powered Objects in Area", "Units Queued Past Pop Cap" };

	Condition()
	{	type=amount=resource=unit_object=unit_location=unit_type=player=technology=timer=-1;
		check=16;cond_unknown = -1;
		area_ll = new POINT();
		area_ur = new POINT();
		unit_group=building_type=ai_signal=-1;
	}
	void writefile(FileWriter fout)
	{	try{
		fout.write("\tCondition:start\r\n");

		fout.write("\t\tCondition_Type:"+strtype[type]+"\r\n");
		//fout.write("\t\t<check>"+check+"</check>\r\n"); ... constant
		if(amount!=-1) fout.write("\t\tCondition_Amount:"+amount+"\r\n");
		if(resource!=-1) fout.write("\t\tCondition_Resource:"+resource+"\r\n");
		if(unit_object!=-1) fout.write("\t\tCondition_Unit_object:"+unit_object+"\r\n");
		if(unit_location!=-1) fout.write("\t\tCondition_Unit_location:"+unit_location+"\r\n");
		if(unit_type!=-1) fout.write("\t\tCondition_Unit_type:"+unit_type+"\r\n");
		if(player!=-1) fout.write("\t\tCondition_Player:"+player+"\r\n");
		if(technology!=-1) fout.write("\t\tCondition_Technology:"+technology+"\r\n");
		if(timer!=-1) fout.write("\t\tCondition_Timer:"+timer+"\r\n");
		//fout.write("\t\t<cond_unknown>"+cond_unknown+"</cond_unknown>\r\n"); //... constant
		if(area_ll.exists()) fout.write("\t\tCondition_Area_ll:"+area_ll.x+","+area_ll.y+"\r\n");
		if(area_ur.exists()) fout.write("\t\tCondition_Area_ur:"+area_ur.x+","+area_ur.y+"\r\n");

		if(unit_group!=-1) fout.write("\t\tCondition_Unit_group:"+unit_group+"\r\n");
		if(building_type!=-1) fout.write("\t\tCondition_Building_type:"+building_type+"\r\n");
		if(ai_signal!=-1) fout.write("\t\tCondition_Ai_signal:"+ai_signal+"\r\n");

		fout.write("\tEndCondition:end\r\n");
		}catch(Exception e) { System.out.println("error in writing conditions "+e); e.printStackTrace();
		}
	}

	void writetoscx(FileOutputStream fout)
	{	try{
			//Write conditions
			fout.write(bytefromint(type));
			fout.write(bytefromint(check));
			fout.write(bytefromint(amount));
			fout.write(bytefromint(resource));
			fout.write(bytefromint(unit_object));
			fout.write(bytefromint(unit_location));
			fout.write(bytefromint(unit_type));
			fout.write(bytefromint(player));
			fout.write(bytefromint(technology));
			fout.write(bytefromint(timer));
			cond_unknown = -1;
			fout.write(bytefromint(cond_unknown));
			fout.write(bytefromint(area_ll.x));	fout.write(bytefromint(area_ll.y));
			fout.write(bytefromint(area_ur.x)); fout.write(bytefromint(area_ur.y));
			fout.write(bytefromint(unit_group));
			fout.write(bytefromint(building_type));

			fout.write(bytefromint(ai_signal));

		}catch(Exception e) {System.out.println("error in writing condition to scx "+e);
		}
	}
	byte[] bytefromint(int i) {
		return new byte[] { (byte)i, (byte)(i>>8), (byte)(i>>16), (byte)(i>>24)  };
	}

	void stringtotype(String s)
	{	for(int i=0;i<strtype.length;i++)
			if(s.equals(strtype[i])) type = i;
	}
}