import java.io.*;

class Effect
{
	int type;	//see constants below
	int check;	//always = 0x17. For internal use by AOK (and AOKTS).
	int ai_goal;	//AI Script goal
	int amount;	//used for resources, hp, attack
	int resource;	//resource type (stone = 2)
	int diplomacy;	//state for change diplomacy (see constants below)
	int num_selected;	//number of units selected
	int location_unit;	//Unit ID for location setting
	int unit_type;	//unit constant for create object, etc.
	int player_source;
	int player_target;
	int technology;	//see "Complete Constant Lists" in AOKH utilities
	int stringid;	//as in string table
	int eff_unknown;
	int display_time;	//for Display Instructions
	int trigger;	//trigger index for Activate/Deactivate Trigger
	POINT location;
	POINT area_ll;	//lower-left corner of area
	POINT area_ur;	//upper-right corner
	int unit_group;
	int building_type;	//Civilian, Military, Building, Other
	int instruction_panel;
	int text_len;
	String text; //Of size text_len .. Instructions/Chat
	int sound_len;
	String sound_file ;//of length [sound_len]
	int unit_ids[]; //of size num_selected;

	//Constants
	final String strtype[] = { "whoknows", "Change Diplomacy", "Research Technology","Send Chat","Play Sound","Send Tribute","Unlock Gate",
					"Lock Gate","Activate Trigger","Deactivate Trigger","AI Script Goal","Create Object","Task Object",
					"Declare Victory","Kill Object","Remove Object","Change View","Unload","Change Ownership",
					"Patrol","Display Instructions","Clear Instructions","Freeze Unit","Use Advanced Buttons",
					"Damage Object","Place Foundation","Change Object Name","Change Object HP","Change Object Attack",
					"Stop Unit","Snap View","Unknown","Enable Tech","Disable Tech","Enable Unit","Disable Unit","Flash Objects" };
	//Constants for resource, diplomacy, units, techs and so on.


	Effect()
	{	//Default values
		type=ai_goal=amount=resource=diplomacy=num_selected=location_unit=unit_type = -1;
		player_source=player_target=technology=stringid=eff_unknown=display_time=trigger= -1;

		location = new POINT();
		area_ll = new POINT();
		area_ur = new POINT();

		unit_group=building_type=instruction_panel= -1;
		text_len=sound_len=0;
		check = 23;
		text = ""; sound_file = "";
	}
	//Apart from default values, they are set outside the class as there are too many of them
	void writefile(FileWriter fout)
	{	try{

		fout.write("\tEffect:start\r\n");
		fout.write("\t\tEffect_Type:"+strtype[type]+"\r\n");
		//fout.write("\t\t<check>"+check+"</check>\r\n");

		if(ai_goal!=-1) fout.write("\t\tEffect_Ai_goal:"+ai_goal+"\r\n");
		if(amount!=-1) fout.write("\t\tEffect_Amount:"+amount+"\r\n");
		if(resource!=-1) fout.write("\t\tEffect_Resource:"+resource+"\r\n");
		if(diplomacy!=-1) fout.write("\t\tEffect_Diplomacy:"+diplomacy+"\r\n");
		if(num_selected!=-1) fout.write("\t\tEffect_Num_selected:"+num_selected+"\r\n");
		if(location_unit!=-1) fout.write("\t\tEffect_Location_unit:"+location_unit+"\r\n");
		if(unit_type!=-1) fout.write("\t\tEffect_Unit_type:"+unit_type+"\r\n");
		if(player_source!=-1) fout.write("\t\tEffect_Player_source:"+player_source+"\r\n");
		if(player_target!=-1) fout.write("\t\tEffect_Player_target:"+player_target+"\r\n");
		if(technology!=-1) fout.write("\t\tEffect_Technology:"+technology+"\r\n");
		if(stringid!=-1) fout.write("\t\tEffect_Stringid:"+stringid+"\r\n");

		//if(eff_unknown!=-1)
		//fout.write("\t\t<eff_unknown>"+eff_unknown+"</eff_unknown>\r\n");

		if(display_time!=-1) fout.write("\t\tEffect_Display_time:"+display_time+"\r\n");
		if(trigger!=-1) fout.write("\t\tEffect_Efftrigger:"+trigger+"\r\n");
		if(location.exists()) fout.write("\t\tEffect_Location:"+location.x+","+location.y+"\r\n");
		if(area_ll.exists()) fout.write("\t\tEffect_Area_ll:"+area_ll.x+","+area_ll.y+"\r\n");
		if(area_ur.exists()) fout.write("\t\tEffect_Area_ur:"+area_ur.x+","+area_ur.y+"\r\n");
		if(unit_group!=-1) fout.write("\t\tEffect_Unit_group:"+unit_group+"\r\n");
		if(building_type!=-1) fout.write("\t\tEffect_Building_type:"+building_type+"\r\n");
		if(instruction_panel!=-1) fout.write("\t\tEffect_Instruction_panel:"+instruction_panel+"\r\n");
		if(text_len>1) fout.write("\t\tEffect_Text:"+text.substring(0,text.length())+"\r\n");

		//problem with sound_len and text
		//Same problem as desc_len
		//Apparently when there is text, sound file is empty
		if(sound_len>1) fout.write("\t\tEffect_Sound_file:"+sound_file.substring(0,sound_file.length())+"\r\n");

		//Unit ids
		if(num_selected>0)
		{
		fout.write("\t\tEffect_Unit_ids:start\r\n");
		for(int i=0;i<unit_ids.length;i++)
			fout.write("\t\t\tId:"+unit_ids[i]+"\r\n");
		fout.write("\t\tEffect_EndUnit_ids:end\r\n");

		}

		fout.write("\tEndEffect:end\r\n");

		}catch(Exception e) {System.out.println("error in writing effect "+e);e.printStackTrace();
		}

	}
	void writetoscx(FileOutputStream fout)
	{	try{
			fout.write(bytefromint(type));
			fout.write(bytefromint(check));
			fout.write(bytefromint(ai_goal));
			fout.write(bytefromint(amount));
			fout.write(bytefromint(resource));
			fout.write(bytefromint(diplomacy));
			fout.write(bytefromint(num_selected));
			fout.write(bytefromint(location_unit));
			fout.write(bytefromint(unit_type));
			fout.write(bytefromint(player_source));
			fout.write(bytefromint(player_target));
			fout.write(bytefromint(technology));
			fout.write(bytefromint(stringid));
			//eff_unknown = type;
			fout.write(bytefromint(eff_unknown));
			fout.write(bytefromint(display_time));
			fout.write(bytefromint(trigger));

			fout.write(bytefromint(location.x)); fout.write(bytefromint(location.y));
			fout.write(bytefromint(area_ll.x)); fout.write(bytefromint(area_ll.y));
			fout.write(bytefromint(area_ur.x)); fout.write(bytefromint(area_ur.y));

			fout.write(bytefromint(unit_group));
			fout.write(bytefromint(building_type));
			fout.write(bytefromint(instruction_panel));
			fout.write(bytefromint(text_len));
			if(text_len>0)
			{	fout.write(text.getBytes());
				fout.write(0);//A byte
			}
			fout.write(bytefromint(sound_len));

			if(sound_len>0)
			{	if(sound_len>1) fout.write(sound_file.getBytes());

				fout.write(0);//A byte
			}


			//Unit ids
			if(num_selected>0)
			{	for(int i=0;i<unit_ids.length;i++)
					fout.write(bytefromint(unit_ids[i]));
			}

		}catch(Exception e) {System.out.println("error in writing effect to scx "+e);
		}
	}
	byte[] bytefromint(int i) {
		return new byte[] { (byte)i, (byte)(i>>8), (byte)(i>>16), (byte)(i>>24)  };
	}
	void stringtotype(String s)
	{	for(int i=0;i<strtype.length;i++)
			if(s.equals(strtype[i])) type = i;
	}
}