import java.io.*;

class Trigger
{
	boolean enabled;//Boolean with 4 bytes
	boolean looping;//Boolean with 4 bytes
	int unknown; //Unknown byte
	boolean objective;	//listed in objectives?
	int desc_order;	//order in objectives
	int zeros;
	int desc_len;
	String description; //Of length[desc_len]
	int name_len;		//max 44
	String name; //Of length[name_len]

	int num_effects;
	Effect effects[]; //of size [num_effects]	//size varies with strings
	int effect_order[]; //of size [num_effects]

	int num_conditions;
	Condition conditions[]; //Of size [num_conditions]
	int condition_order[]; //Of size [num_conditions]

	void setorders()
	{	effect_order = new int[num_effects];
		for(int i=0;i<num_effects;i++)
			effect_order[i] = i;

		condition_order = new int[num_conditions];
		for(int i=0;i<num_conditions;i++)
			condition_order[i] = i;
	}
	int readfromscx(String filename, int bytes_skip)
	//Returns the number of bytes this function has read
	{	try{
		int currentbyte;
		int num_bytes_used = 0;

		FileInputStream fin = new FileInputStream(filename);
		fin.skip(bytes_skip);

		byte benabled[] = new byte[4];
		fin.read(benabled,0,4); num_bytes_used += 4;
		if(bytetoint(benabled)==1) enabled = true; else enabled = false;
    	byte blooping[] = new byte[4];
    	fin.read(blooping,0,4); num_bytes_used += 4;
    	if(bytetoint(blooping)==1) looping = true; else looping = false;

    	//1 byte unknown
    	unknown = fin.read(); num_bytes_used += 1;

    	currentbyte = fin.read(); num_bytes_used += 1;
    	if (currentbyte==1) objective = true; else objective = false;

    	//long desc_order
		desc_order = read_long(fin); num_bytes_used += 4;

        //4 byte zeroes
        byte bzeroes[] = new byte[4];
        fin.read(bzeroes,0,4); num_bytes_used += 4;
        String zeroes = new String(bzeroes);
        //long desc_len
		desc_len = read_long(fin); num_bytes_used += 4;

        //char description[desc_len]
        //Will be of length desc_len except in the case where desc_len is 0
        //remember desc and description problem
        String desc;
        desc = read_string(fin,desc_len); num_bytes_used += desc_len;
        //Remember desc_len changed to > 1
        if(desc_len>1)
        {	description = desc.substring(0,desc.length()-1);
        }

        //Name length
        name_len = read_long(fin); num_bytes_used += 4;

        byte bname[] = new byte[name_len];
        fin.read(bname,0,name_len); num_bytes_used += name_len;
        name = new String(bname);
        if(name_len>1) name = name.substring(0,name.length()-1);

        //Effects
		num_effects = read_long(fin); num_bytes_used += 4;
    	effects = new Effect[num_effects];

		for(int j=0;j<num_effects;j++)
		{	effects[j] = new Effect();

			effects[j].type = read_long(fin);	//see constants below
			effects[j].check = read_long(fin);		//always = 0x17. For internal use by AOK (and AOKTS).
			effects[j].ai_goal  = read_long(fin);		//AI Script goal
			effects[j].amount = read_long(fin);		//used for resources, hp, attack
			effects[j].resource  = read_long(fin);		//resource type (stone = 2)
			effects[j].diplomacy  = read_long(fin);		//state for change diplomacy (see constants below)
			effects[j].num_selected  = read_long(fin);		//number of units selected
			effects[j].location_unit = read_long(fin);	//Unit ID for location setting
			effects[j].unit_type = read_long(fin);		//unit constant for create object, etc.
			effects[j].player_source = read_long(fin);
			effects[j].player_target = read_long(fin);
			effects[j].technology = read_long(fin);	//see "Complete Constant Lists" in AOKH utilities
			effects[j].stringid = read_long(fin);		//as in string table
			effects[j].eff_unknown = read_long(fin);
			effects[j].display_time = read_long(fin);		//for Display Instructions
			effects[j].trigger = read_long(fin);	//trigger index for Activate/Deactivate Trigger

			effects[j].location = new POINT(read_long(fin),read_long(fin));
			effects[j].area_ll = new POINT(read_long(fin),read_long(fin));	//lower-left corner of area
			effects[j].area_ur = new POINT(read_long(fin),read_long(fin));	//upper-right corner

			effects[j].unit_group = read_long(fin);
			effects[j].building_type = read_long(fin);	//Civilian, Military, Building, Other
			effects[j].instruction_panel = read_long(fin);
			effects[j].text_len = read_long(fin);

			num_bytes_used += 4*26;
			//System.out.println(num_bytes_used);
			//System.out.println(effects[j].text_len);

			String eff_text = read_string(fin,effects[j].text_len);	//Instructions/Chat
			//Correction added for text_len and sound_len
			if(effects[j].text_len>1) effects[j].text = eff_text.substring(0,eff_text.length());

			num_bytes_used += effects[j].text_len;
			effects[j].sound_len = read_long(fin); num_bytes_used += 4;

			String eff_sound = read_string(fin,effects[j].sound_len);
			if(effects[j].sound_len>1) effects[j].sound_file = eff_sound.substring(0,eff_sound.length());

			num_bytes_used += effects[j].sound_len;

			if(effects[j].num_selected!=-1)
			{
				effects[j].unit_ids = new int[effects[j].num_selected];
				for(int k=0;k<effects[j].num_selected;k++)
				{	effects[j].unit_ids[k] = read_long(fin);num_bytes_used += 4;
				}
			}

		}

		//Effect orders

		effect_order = new int[num_effects];
		for(int j=0;j<num_effects;j++)
		{	effect_order[j] = read_long(fin);num_bytes_used += 4;
		}
		//Conditions

		num_conditions = read_long(fin); num_bytes_used += 4;
		conditions = new Condition[num_conditions];

		for(int j=0;j<num_conditions;j++)
		{	conditions[j]= new Condition();

			conditions[j].type = read_long(fin);	//see constants below
			conditions[j].check = read_long(fin);	//always = 0x10 (for internal use)
			conditions[j].amount = read_long(fin);	//of objects, difficult level
			conditions[j].resource = read_long(fin);	//resource type (see constants below)
			conditions[j].unit_object = read_long(fin);
			conditions[j].unit_location = read_long(fin); //Problem with unit location
			//if(conditions[j].unit_location != -1) System.out.println("Unit location: "+conditions[j].unit_location);

			conditions[j].unit_type = read_long(fin);
			conditions[j].player = read_long(fin);
			conditions[j].technology = read_long(fin);	//see "Complete Constant Lists" in AOKH utilities
			conditions[j].timer = read_long(fin);
			conditions[j].cond_unknown = read_long(fin);
			conditions[j].area_ll = new POINT(read_long(fin),read_long(fin));
			conditions[j].area_ur = new POINT(read_long(fin),read_long(fin));
			conditions[j].unit_group = read_long(fin);	//see constants below
			conditions[j].building_type = read_long(fin);//Civilian, Military, Building, Other
			conditions[j].ai_signal = read_long(fin);
			num_bytes_used += 4*18;
		}

		//Condition order
		condition_order = new int[num_conditions];
		for(int j=0;j<num_conditions;j++)
		{	condition_order[j] = read_long(fin);num_bytes_used += 4;
		}

		fin.close();
		return num_bytes_used;

		}catch(Exception e){ System.out.println("Error reading trigger "+e); e.printStackTrace(); return 0;
		}
	}
	void writetoscript(FileWriter fout)
	{	try{
		fout.write("Trigger:start\r\n");
		fout.write("Enabled:"+enabled+"\r\n");
		fout.write("Looping:"+looping+"\r\n");
		fout.write("Objective:"+objective+"\r\n");
		fout.write("Desc_order:"+desc_order+"\r\n");
		if(desc_len>1) fout.write("Description:"+description+"\r\n");
		if(name_len>1) fout.write("Name:"+name+"\r\n");

		for(int j=0;j<num_conditions;j++)
			conditions[condition_order[j]].writefile(fout);

		for(int j=0;j<num_effects;j++)
			effects[effect_order[j]].writefile(fout);

		fout.write("Endtrigger:end\r\n");
		}catch(Exception e){ System.out.println("Error writing trigger to script"+e); e.printStackTrace();
		}
	}
	//Remember this is appending
	void writetoscx(String filename)
	{	//Writes to a file in decompressed scx format
		try{
			FileOutputStream fout = new FileOutputStream(filename,true);

			//Write trigger header
			if(enabled) fout.write(bytefromint(1)); else fout.write(bytefromint(0));
			if(looping) fout.write(bytefromint(1)); else fout.write(bytefromint(0));
			fout.write((byte)(unknown));
			if(objective) fout.write(1); else fout.write(0);
			fout.write(bytefromint(desc_order));
			fout.write(bytefromint(zeros));
			fout.write(bytefromint(desc_len));
			if(desc_len>1) { fout.write(description.getBytes()); fout.write(0); }
			fout.write(bytefromint(name_len));
			if(name_len>1) { fout.write(name.getBytes());	fout.write(0); }

			//Write effects
			fout.write(bytefromint(num_effects));
			for(int i=0;i<num_effects;i++)
			{	effects[i].writetoscx(fout);
			}

			//Write effect orders
			for(int i=0;i<num_effects;i++)
			{	fout.write(bytefromint(effect_order[i]));
			}

			//Write conditions
			fout.write(bytefromint(num_conditions));
			for(int i=0;i<num_conditions;i++)
			{	conditions[i].writetoscx(fout);
			}

			//Write condition orders
			for(int i=0;i<num_conditions;i++)
			{	fout.write(bytefromint(condition_order[i]));
			}

			fout.close();

		}catch(Exception e){ System.out.println("Error writing trigger "+e); e.printStackTrace();
		}
	}
	int bytetoint(byte a[])
	{	//Converts a 4-byte array to it's integer value
		return  (((int)a[3]&0xff)<<24)
                    | (((int)a[2]&0xff)<<16)
                    | (((int)a[1]&0xff)<<8)
                    | (int)a[0]&0xff;
	}
	//Returns 4 byte array from an integer
	byte[] bytefromint(int i) {
		return new byte[] { (byte)i, (byte)(i>>8), (byte)(i>>16), (byte)(i>>24)  };
	}
	int read_long(FileInputStream f)
	{	//Reads a long, ie 4 byte integer from the stream and returns it.
		byte b[] = new byte[4];
		try{
		f.read(b,0,4);
		}catch(Exception e) {System.out.println("error "+e);
		}
		return bytetoint(b);
	}
	String read_string(FileInputStream f,int length)
	{	//Reads a String of given length from the stream and returns it
		byte b[] = new byte[length];
		try{
		f.read(b,0,length);
		}catch(Exception e) {System.out.println("error "+e);
		}
		return new String(b);
	}
}