import java.io.*;

class scenario
{	//header values
	int numplayers;
	int numtriggers;
	//Start, end values
	int triggerstart;
	int triggerend;

	void decompress(String filename)
	{	//Extracts the header and the decompressed file.
		//Writes the header to header.hex and decompressed file to tempscn.hex
		try{
			FileInputStream fin = new FileInputStream(filename);

			File file_input = new File(filename);
			String fileout = file_input.getName();
			System.out.println(fileout);

			int bytesread = 0;

			int vlen = 4; //4 byte version name
        	byte version[]=new byte[vlen];
        	fin.read(version,0,vlen); bytesread += vlen;

        	byte hlen[] = new byte[4];//Length of the header, long
        	fin.read(hlen,0,4); bytesread += 4;

        	int headerlength = (((int)hlen[3]&0xff)<<24)
                    | (((int)hlen[2]&0xff)<<16)
                    | (((int)hlen[1]&0xff)<<8)
                    | (int)hlen[0]&0xff;

            System.out.println("header length: "+headerlength);

            byte header[] = new byte[headerlength-4];
            fin.read(header,0,headerlength-4);
            byte plen[] = new byte[4];
            fin.read(plen,0,4);
            bytesread += headerlength;

            numplayers = (((int)plen[3]&0xff)<<24)
                    | (((int)plen[2]&0xff)<<16)
                    | (((int)plen[1]&0xff)<<8)
                    | (int)plen[0]&0xff;
            System.out.println("number of players: "+numplayers);

            System.out.println("bytesread: "+bytesread);

            int compressedlength = fin.available();
            byte cdata[] = new byte[compressedlength];
            fin.read(cdata,0,compressedlength);
            fin.close();
            FileOutputStream fout = new FileOutputStream("rest.txt");
            fout.write(cdata);
            fout.close();

            //Writing header
            cdata = new byte[bytesread];
            fin = new FileInputStream(filename);
            fout = new FileOutputStream("header.hex");
            fin.read(cdata,0,bytesread);
            fin.close();
            fout.write(cdata);

            Process p = Runtime.getRuntime().exec("uncompr rest.txt "+"tempscn.hex");

			BufferedReader stdInput = new BufferedReader(new InputStreamReader(p.getInputStream()));
            		String scom;
			while ((scom = stdInput.readLine()) != null) {
			}

			fout.close();
			//Delete the temporary file rest.txt
			File f_del = new File("rest.txt");
			f_del.delete();

		}
		catch(Exception e) {System.out.println("error decompressing"+e);
		}
	}

	void read(String filename, String outfile)
	{	//Reads rest.hex into triggers etc.
		//Basically we just want the triggers.. so skip ahead bytes.
		try{
			FileInputStream fin = new FileInputStream(filename);
			FileWriter fout = new FileWriter(outfile);
			fout.write("Scenario:\r\n");
			//Look for trigger0, get position in string and skip ahead that many bytes.

			int num_initial_skip = 0;

        	num_initial_skip = skipping(filename);
        	triggerstart = num_initial_skip;
        	System.out.println("Skipped: "+num_initial_skip);

        	fin.skip(num_initial_skip);

        	numtriggers = read_long(fin);

            System.out.println("Number of triggers: "+numtriggers);
            Trigger triggers[] = new Trigger[numtriggers];

            int numskip = 0;
            //Goes haywire after a while due to low memory- corrected
            for(int i=0;i<numtriggers;i++)
            {	triggers[i] = new Trigger();
            	numskip += triggers[i].readfromscx(filename,num_initial_skip+4+numskip);

            	fout.write("# -- Trigger"+(i+1)+"-- \r\n");
            	triggers[i].writetoscript(fout);
            }
            //At the end there is numtriggers ints representing the orders.
            //We'll just skip them because they don't matter
            fin.skip(4*numtriggers);
            numskip += 4*numtriggers;

            triggerend = num_initial_skip+4+numskip;

            fout.write("End Scenario:\r\n");
            fout.close();
			fin.close();
		}catch(Exception e) {System.out.println("error in reading trigger "+e); e.printStackTrace();
		}
	}
	//Method to write to the scenario
	void write(String inputscen, String outputfile, String scriptfile)
	{	try{

		//Assume already read
		//So that we know triggerstart and triggerend
		FileInputStream fin = new FileInputStream("tempscn.hex");
		FileOutputStream fout = new FileOutputStream("out.hex");

		int bytesread = 0;
		//Write everything up to triggerstart
		do{
			int b = fin.read();	fout.write(b);
			bytesread++;
		}while(bytesread<triggerstart);

		System.out.println("\n Triggerstart :"+triggerstart);

		scriptreader reader = new scriptreader();
		numtriggers = reader.read(scriptfile,"triggers.hex");

		//Write the number of triggers
		fout.write(bytefromint(numtriggers));

		//Now write everything from triggers.hex into fout
		FileInputStream ftrigger = new FileInputStream("triggers.hex");

		while(ftrigger.available()>0)
		{	int b = ftrigger.read();	fout.write(b);
		}

		//Now write the trigger list
		for(int i=1;i<=numtriggers;i++)
			fout.write(bytefromint(i-1));

		//Skip to triggerend
		fin.skip(triggerend-triggerstart);

		System.out.println("Triggerend : "+triggerend);

		//Write everything till end
		while(fin.available()>0)
		{	int b = fin.read();	fout.write(b);
		}

		//Close files, compress out.hex
		fin.close(); fout.close(); ftrigger.close();

		Process p = Runtime.getRuntime().exec("compr out.hex comprout.hex");

		BufferedReader stdInput = new BufferedReader(new InputStreamReader(p.getInputStream()));
        		String scom;
		while ((scom = stdInput.readLine()) != null) {
		}

		//Join up with the header file
		fin = new FileInputStream("header.hex");
		fout = new FileOutputStream(outputfile);
		while(fin.available()>0)
		{	int b = fin.read();	fout.write(b);
		}

		fin = new FileInputStream("comprout.hex");
		while(fin.available()>0)
		{	int b = fin.read();	fout.write(b);
		}

		//New scx file written. Done
		fin.close();fout.close();

		//Delete the temporary files triggers.hex, out.hex, comprout.hex

		File f_del = new File("triggers.hex");
		f_del.delete();
		f_del = new File("out.hex");
		f_del.delete();
		f_del = new File("comprout.hex");
		f_del.delete();


		}catch(Exception e) {System.out.println("error in writing file "+e); e.printStackTrace();
		}
	}
	//Returns how much to skip ahead
	int skipping(String filename)
	{	try{
			FileInputStream fin = new FileInputStream(filename);

			int bytesread = 0; int n;
			byte strlen[] = new byte[2];
			//Skip ahead 4433 bytes - size of CHeader till the scenario's filename
			int bytesavailable = fin.available();

			fin.skip(4433); bytesread += 4433;
			//Next 2 bytes give the size of the String to follow

        	int namelen = read_short(fin); bytesread += 2;
        	fin.skip(namelen+24);//24 empty bytes follow the namelength
        	bytesread += namelen+24;

        	//Now read instructions, hints, victory, defeat, history, scouts

        	//instructions
        	namelen = read_short(fin); bytesread += 2;
        	fin.skip(namelen); bytesread += namelen;

        	//hints
        	namelen = read_short(fin); bytesread += 2;
        	fin.skip(namelen); bytesread += namelen;

        	//victory
        	namelen = read_short(fin); bytesread += 2;
        	fin.skip(namelen); bytesread += namelen;

        	//defeat
        	namelen = read_short(fin); bytesread += 2;
        	fin.skip(namelen); bytesread += namelen;

        	//history
        	namelen = read_short(fin); bytesread += 2;
        	fin.skip(namelen); bytesread += namelen;

        	//scouts
        	namelen = read_short(fin); bytesread += 2;
        	fin.skip(namelen); bytesread += namelen;

        	//Do the same for cinematic thingies. pg_cinem, vict_cinem, loss_cinem, background

        	//pg_cinem
        	namelen = read_short(fin); bytesread += 2;
        	fin.skip(namelen); bytesread += namelen;

        	//vict_cinem
        	namelen = read_short(fin); bytesread += 2;
        	fin.skip(namelen); bytesread += namelen;

        	//loss_cinem
        	namelen = read_short(fin); bytesread += 2;
        	fin.skip(namelen); bytesread += namelen;

        	//background_cinem
        	namelen = read_short(fin); bytesread += 2;
        	fin.skip(namelen); bytesread += namelen;

        	//boolean to indicate bitmap or not
        	n = read_long(fin); bytesread += 4; //4 bytes boolean
        	//System.out.println(n);

        	//Length and width of bitmap
        	int x = read_long(fin);bytesread += 4; //bitmap x and y
        	int y = read_long(fin);bytesread += 4; //4 bytes boolean
        	//System.out.println(x+" "+y);

        	//whocares
        	fin.skip(2); bytesread += 2;

        	if(n==1)
        	{
	        	//Bitmap header etc.
	        	fin.skip(4+4+4+2+2+4); bytesread += 20;

	        	int bitmap_size = read_long(fin); bytesread += 4;
	        	//System.out.println("Bitmap size in bytes: "+bitmap_size);

	        	//Skip rest of the header ( 40-20-4 = 16 bytes )
	        	fin.skip(16); bytesread += 16;

	        	//Skip 1024 bytes for palette
	        	fin.skip(1024);  bytesread += 1024;

	        	//Skip bitmap bits
	        	fin.skip(bitmap_size); bytesread += bitmap_size;
        	}
        	//Player data 2

        	//32 unknowns
        	for(int i=1;i<=32;i++)
        	{	namelen = read_short(fin); bytesread += 2;
        		fin.skip(namelen); bytesread += namelen;
        	}

        	//16 ai names
        	for(int i=1;i<=16;i++)
        	{	namelen = read_short(fin); bytesread += 2;
	        	String str = read_string(fin,namelen); bytesread += namelen;
	        	//System.out.println(str);
        	}

        	//Read 16 AIs
        	for(int i=1;i<=16;i++)
        	{
	        	fin.skip(8); bytesread += 8; //Two null strings
	        	int ai_length = read_long(fin); bytesread +=4 ;
	        	//System.out.println(ai_length);
	        	fin.skip(ai_length); bytesread += ai_length;
        	}

        	//Read 16 AI types ( 1 byte values )
        	fin.skip(16); bytesread += 16;

        	//Separator 0xFFFFFF9D
        	fin.skip(4); bytesread +=4;

        	//Resources
        	for(int i=1;i<=16;i++)
        	{	//gold, wood, food, stone, porex - all long
        		fin.skip(20);
        		//Null long
	        	fin.skip(4); bytesread += 24;
        	}

        	//Victory

        	//Separator 0xFFFFFF9D
        	fin.skip(4); bytesread +=4;
        	//Conquest
        	int conquest = read_long(fin); bytesread +=4;
        	//zeros1
        	fin.skip(4); bytesread +=4;
        	//relics
        	int relics = read_long(fin); bytesread +=4;
        	//zeros2
        	fin.skip(4); bytesread +=4;
        	//explored
        	fin.skip(4); bytesread +=4;
        	//zeros3
        	fin.skip(4); bytesread +=4;
        	//BOOL all
        	int all = read_long(fin); bytesread +=4;

        	//Mode, score, time
        	fin.skip(12); bytesread +=12;

        	//Diplomacy
        	//16x16 longs
        	for(int i=1;i<=16;i++)
        	{	for(int j=1;j<=16;j++)
        		{	int dipl = read_long(fin); bytesread += 4;
        			//System.out.print(dipl+" ");
        		}
        		//System.out.println();
        	}

        	//Skip 11520 bytes
        	fin.skip(11520); bytesread +=11520;
        	//Separator 0xFFFFFF9D
        	fin.skip(4); bytesread +=4;

        	//16 allied victory's ( long )
        	fin.skip(64); bytesread +=64;

        	//Techs
        	//num_d techs - 16 longs
        	fin.skip(64); bytesread +=64;
        	//disabled techs - 16x30 longs
        	fin.skip(64*30); bytesread +=64*30;
        	//num_d units - 16 longs
        	fin.skip(64); bytesread +=64;
        	//disabled units - 16x30 longs
        	fin.skip(64*30); bytesread +=64*30;
        	//num_d buildings - 16 longs
        	fin.skip(64); bytesread +=64;
        	//disabled units - 16x20 longs
        	fin.skip(64*20); bytesread +=64*20;
        	//2 null longs
        	fin.skip(8); bytesread +=8;
        	//long alltechs
        	int alltechs = read_long(fin); bytesread +=4;
        	//Starting age: 16 longs

        	for(int i=1;i<=16;i++)
        	{	int age = read_long(fin); bytesread +=4;
        		//System.out.println("Age "+age);
        	}

        	//Map
        	//Separator 0xFFFFFF9D
        	fin.skip(4); bytesread +=4;

        	//Camera position - 2 longs
        	fin.skip(8); bytesread +=8;

        	//Long aitype
        	fin.skip(4); bytesread +=4;

        	//Map x, y
        	int mapx = read_long(fin);  bytesread +=4;
        	int mapy = read_long(fin);  bytesread +=4;
        	System.out.println("Map: "+mapx+" , "+mapy);

        	//Terrain: x,y,3 - ID, elevation, null- each is 1 byte
        	fin.skip(mapx*mapy*3); bytesread += mapx*mapy*3;

        	//Units
        	//Number of players long
        	int numplayers = read_long(fin); bytesread +=4;
        	//System.out.println("players : "+numplayers);

        	//Playerdata4 for 8 players
        	for(int i=1;i<=8;i++)
        	{	//Resources
        		//Read 6 floats
        		fin.skip(24); bytesread +=24;

        		//Pop limit- float;
        		fin.skip(4); bytesread += 4;
        	}

        	//Unit data
        	//Only 9 players can have inputs
        	for(int i=1;i<=9;i++)
        	{
	        	int count = read_long(fin); bytesread += 4;
	        	//System.out.println("number of units player "+i+" is "+count);

	        	//Units
	        	for(int j=1;j<=count;j++)
	        	{	float xpos = read_float(fin); bytesread += 4;
	        		float ypos = read_float(fin); bytesread += 4;
	        		//System.out.println("Position "+xpos+" "+ypos);
	        		//who knows
	        		fin.skip(4); bytesread += 4;
	        		//long id
	        		int id = read_long(fin); bytesread += 4;
	        		//short constant
	        		fin.skip(2); bytesread += 2;
	        		//who cares
	        		fin.skip(1); bytesread += 1;
	        		//rotation
	        		float rotation = read_float(fin); bytesread += 4;
	        		//System.out.println("rotation "+rotation);
	        		//short frame
	        		int frame = read_short(fin); bytesread += 2;
	        		//System.out.println("frame "+frame);
	        		//long garrison
	        		int garrison = read_long(fin); bytesread += 4;
	        		//System.out.println("garrison "+garrison);
	        	} //end of j

        		//System.out.println("Bytesread "+bytesread);
        		//System.out.println("Bytes actually read: "+ ( bytesavailable- fin.available() ) );
        	}//end of i

        	//Player data 3

        	//Separator 0x09000000
        	fin.skip(4); bytesread +=4;
        	//Player data 3

        	for(int i=1;i<=8;i++)
        	{	//length
        		int len = read_short(fin);  bytesread += 2;
        		//Player name
        		String plname = read_string(fin, len);  bytesread += len;
        		//System.out.println("Player "+plname);
        		//Camera positions - 2 floats
        		fin.skip(8);  bytesread += 8;
        		//Unknown shorts - 2
        		fin.skip(4);  bytesread +=4;
        		//bool alliedvictory - 1 byte
        		fin.skip(1);  bytesread +=1;
        		//short countdiplomacy
        		int countdiplomacy = read_short(fin);  bytesread += 2;
        		//char[countdiplomacy]
        		fin.skip(countdiplomacy);  bytesread += countdiplomacy;
        		//long[countdiplomacy]
        		fin.skip(countdiplomacy*4);  bytesread += countdiplomacy*4;
        		//long color
        		fin.skip(4);  bytesread +=4;
        		//float n_pldata
        		float n_pldata = read_float(fin);  bytesread +=4;
        		//long nulls[n_pldata]
        		fin.skip(4*(int)n_pldata);  bytesread += 4*(int)n_pldata;
        		//char nulls2[9]
        		fin.skip(9);  bytesread += 9;
        		//long end = -1
        		fin.skip(4);  bytesread +=4;

        	}

        	//constant double 1.6 //8 bytes
        	fin.skip(8); bytesread +=8;

        	//Start of trigger: 1st one byte 0
        	fin.skip(1);  bytesread += 1;

        	//System.out.println("Bytesread "+bytesread);
        	//System.out.println("Bytes actually read: "+ ( bytesavailable- fin.available() ) );

        	fin.close();
        	return bytesread;

		}
		catch(Exception e) {System.out.println("error in reading trigger "+e); e.printStackTrace();
			return -1;
		}
	}
	int bytetoint(byte a[])
	{	//Converts a 4-byte array to it's integer value
		return  (((int)a[3]&0xff)<<24)
                    | (((int)a[2]&0xff)<<16)
                    | (((int)a[1]&0xff)<<8)
                    | (int)a[0]&0xff;
	}
	int read_long(FileInputStream f)
	{	//Reads a long, ie 4 byte integer from the stream and returns it.
		byte b[] = new byte[4];
		try{
		f.read(b,0,4);
		}catch(Exception e) {System.out.println("error "+e);
		}
		return bytetoint(b);
	}
	String read_string(FileInputStream f,int length)
	{	//Reads a String of given length from the stream and returns it
		byte b[] = new byte[length];
		try{
		f.read(b,0,length);
		}catch(Exception e) {System.out.println("error "+e);
		}
		return new String(b);
	}
	float read_float(FileInputStream f)
	{	//Reads a long, ie 4 byte integer from the stream and returns it.
		byte b[] = new byte[4];
		try{
		f.read(b,0,4);
		}catch(Exception e) {System.out.println("error "+e);
		}
		return Float.intBitsToFloat(bytetoint(b));
	}
	int read_short(FileInputStream f)
	{	//Reads a short, ie 2 byte integer from the stream and returns it.
		byte b[] = new byte[2];
		try{
		f.read(b,0,2);
		}catch(Exception e) {System.out.println("error "+e);
		}
		return (( (int)b[1]&0xff)<<8) | (int)b[0]&0xff ;
	}
	byte[] bytefromint(int i) {
		return new byte[] { (byte)i, (byte)(i>>8), (byte)(i>>16), (byte)(i>>24)  };
	}
}
