//This program implements the trigger script editor
import java.io.*;

class scripteditor
{	public static void main(String arg[])throws IOException
	{	/*Interface
		 *1 - Load scx file
		 *2 - Export triggers to script
		 *3 - Import triggers to scenario
		 *4 - Save scenario
		 */
		try{

		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		System.out.println("==============================================================================");
        System.out.println("----------         Trigger Script editor by Jatayu                ------------");
        System.out.println("==============================================================================");
		System.out.println("   1 Load scx file                  3 Import triggers to scenario");
        System.out.println("   2 Export triggers to script      4 Save scenario               5 Quit");
		System.out.println("==============================================================================");
        String str = br.readLine();
        String scxname = "";
        String path,scriptfile = "";
        boolean found;
        int dotpos;
        scenario scr = new scenario();

		while(!str.equals("5"))
		{
			int select;
			if(!isParsableToInt(str)) str = "10";
			select = Integer.parseInt(str);

			switch(select)
			{	case 1: System.out.println("Enter name of SCX file: ");
						path = br.readLine();
						if(path.equals("")) path = "../scenario\\atlantis.scx";

						found = true;
						/*Do some smart checking*/
						dotpos = path.indexOf(".");
						if(dotpos==-1)
						{
							if(fileexists(path+".scx")) {  scxname = path+".scx"; }
							else if(fileexists("../scenario\\"+path+".scx")) {  scxname = "../scenario\\"+path+".scx"; }
							else found = false;
						}
						else
						{	if(!fileexists(path) && !fileexists("../scenario\\"+path)) found = false;
							if(fileexists("../scenario\\"+path)) scxname = "../scenario\\"+path ;
						}
						if(found==false) { System.out.println("Not found"); break; }

						scr.decompress(scxname);
						//This will create the temporary files tempscn.hex and header.hex
						break;

				case 2: System.out.println("Enter the name of the output file ( stored in ../scripts , eg. output.txt)" );
						String outdir = br.readLine();
						if(outdir.equals("")) outdir = "../scripts\\atlantis.txt";
						else outdir = "../scripts\\"+outdir;

						System.out.println("Exporting triggers");

						scr.read("tempscn.hex",outdir);
						break;

				case 3: System.out.println("Enter name of Script file: ");
						path = br.readLine();
						scriptfile = path;
						if(path.equals("")) path = "../scripts\\atlantis.txt";

						found = true;
						/*Do some smart checking*/
						dotpos = path.indexOf(".");
						if(dotpos==-1)
						{
							if(fileexists(path+".txt")) {  scriptfile = path+".txt"; }
							else if(fileexists("../scripts\\"+path+".txt")) {  scriptfile = "../scripts\\"+path+".txt"; }
							else found = false;
						}
						else
						{	if(!fileexists(path) && !fileexists("../scripts\\"+path)) found = false;
							if(fileexists("../scripts\\"+path)) scriptfile = "../scripts\\"+path ;
						}
						if(found==false) { System.out.println("Not found"); break; }
						else System.out.println("Scriptfile: "+scriptfile);

						break;

				case 4: if(scriptfile.equals("") || scxname.equals(""))
						{	System.out.println("Do steps 1,2,3 first");
							break;
						}
						System.out.println("Enter the name of the output file ( stored in ../scenario, eg output.scx )" );
						String outfilename = br.readLine();
						if(outfilename.equals("")) outfilename = "../scenario\\output.scx";
						else outfilename = "../scenario\\"+outfilename;

						scr.write(scxname,outfilename,scriptfile);
						scriptfile = "";
						scxname = "";
						break;
			}

			System.out.println("==============================================================================");
	        System.out.println("----------         Trigger Script editor by Jatayu                ------------");
	        System.out.println("==============================================================================");
			System.out.println("   1 Load scx file                  3 Import triggers to scenario");
	        System.out.println("   2 Export triggers to script      4 Save scenario               5 Quit");
			System.out.println("==============================================================================");
	        str = br.readLine();
		}

		System.exit(0);

		}catch(NumberFormatException nfe)
			{
				System.out.println("String entered is not a number!");
				BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
				System.out.println("Press enter to exit");
				br.readLine();
			}
	}

	public static boolean fileexists(String x)
	{	File f = new File(x);
		return f.exists();
	}
	public static boolean isParsableToInt(String i)
	{
	try
		{
		Integer.parseInt(i);
		return true;
		}
	catch(NumberFormatException nfe)
		{
		return false;
		}
	}
}
