import java.io.File;
import java.io.*;

//Class for parsing the txt file
//New file format used
class scriptreader
{	//Returns new triggercount
	int read(String filename, String outfile)
	{	try{
		File file = new File(filename);
		System.out.println("Parsing "+filename);

		//Getting the number of triggers
		int numtriggers = getNumTriggers(filename);

		System.out.println("Number of triggers: "+numtriggers);
		Trigger triggers[] = new Trigger[numtriggers];

		FileReader fr = new FileReader(filename);
		BufferedReader br = new BufferedReader(fr);
		String str;
		//Keep reading triggers into the file

		str = br.readLine();//First string should be scenario, so skip
		int current_trigger = 0;
		int current_condition = 0;
		int current_effect = 0;
		int current_line=1;

		while((str = br.readLine()) != null)
		{	current_line++;
			if(str.charAt(0)=='#')
				continue;//comment

			int pos=str.indexOf(":");
			if(pos==-1)
			{
				System.out.println("Following line does not have a : , ignoring- "+str+"\n");
				continue;
			}
			String beforepos = str.substring(0,pos).trim().toLowerCase();
			String afterpos = str.substring(pos+1);

			if(beforepos.equals("trigger"))
			{	triggers[current_trigger] = new Trigger();
				triggers[current_trigger].num_effects = getNumEffects(filename,current_line);
				triggers[current_trigger].effects = new Effect[triggers[current_trigger].num_effects];
				//System.out.println("Trigger "+current_trigger+" has "+triggers[current_trigger].num_effects+" effects ");
				triggers[current_trigger].num_conditions = getNumConditions(filename,current_line);
				triggers[current_trigger].conditions = new Condition[triggers[current_trigger].num_conditions];
				//System.out.println("Trigger "+current_trigger+" has "+triggers[current_trigger].num_conditions+" conditions ");
				current_effect = 0; current_condition=0;
			}
			//Get more info from trigger
			if(beforepos.equals("enabled"))
			{	if(afterpos.equals("true"))
					triggers[current_trigger].enabled = true;
				else
					triggers[current_trigger].enabled = false;
			}

			if(beforepos.equals("looping"))
			{	if(afterpos.equals("true"))
					triggers[current_trigger].looping = true;
				else
					triggers[current_trigger].looping = false;
			}

			if(beforepos.equals("objective"))
			{	if(afterpos.equals("true"))
					triggers[current_trigger].objective = true;
				else
					triggers[current_trigger].objective = false;
			}

			if(beforepos.equals("desc_order"))
			{	triggers[current_trigger].desc_order = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("description"))
			{	triggers[current_trigger].description = afterpos;
				triggers[current_trigger].desc_len = triggers[current_trigger].description.length()+1;
			}

			if(beforepos.equals("name"))
			{	triggers[current_trigger].name = afterpos;
				triggers[current_trigger].name_len = triggers[current_trigger].name.length()+1;
			}

			if(beforepos.equals("endtrigger"))
			{	triggers[current_trigger].setorders();
				current_trigger++;
			}

			//Effects -------------------------------------------------------------------------------------------------

			if(beforepos.equals("effect"))
			{	triggers[current_trigger].effects[current_effect] = new Effect();
			}

			if(beforepos.equals("effect_type"))
			{	triggers[current_trigger].effects[current_effect].stringtotype(afterpos);
			}

			if(beforepos.equals("effect_ai_goal"))
			{	triggers[current_trigger].effects[current_effect].ai_goal = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("effect_amount"))
			{	triggers[current_trigger].effects[current_effect].amount = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("effect_resource"))
			{	triggers[current_trigger].effects[current_effect].resource = Integer.parseInt(afterpos);
			}

			//Diplomacy constants
			if(beforepos.equals("effect_diplomacy"))
			{	triggers[current_trigger].effects[current_effect].diplomacy = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("effect_num_selected"))
			{	triggers[current_trigger].effects[current_effect].num_selected = Integer.parseInt(afterpos);
				triggers[current_trigger].effects[current_effect].unit_ids = new int[triggers[current_trigger].effects[current_effect].num_selected];
			}

			if(beforepos.equals("effect_location_unit"))
			{	triggers[current_trigger].effects[current_effect].location_unit = Integer.parseInt(afterpos);
			}

			//unit type constants
			if(beforepos.equals("effect_unit_type"))
			{	triggers[current_trigger].effects[current_effect].unit_type = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("effect_player_source"))
			{	triggers[current_trigger].effects[current_effect].player_source = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("effect_player_target"))
			{	triggers[current_trigger].effects[current_effect].player_target = Integer.parseInt(afterpos);
			}

			//Tech constants
			if(beforepos.equals("effect_technology"))
			{	triggers[current_trigger].effects[current_effect].technology = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("effect_stringid"))
			{	triggers[current_trigger].effects[current_effect].stringid = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("effect_display_time"))
			{	triggers[current_trigger].effects[current_effect].display_time = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("effect_efftrigger"))
			{	triggers[current_trigger].effects[current_effect].trigger = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("effect_location"))
			{	int pos_comma = afterpos.indexOf(",");
				triggers[current_trigger].effects[current_effect].location = new POINT(Integer.parseInt(afterpos.substring(0,pos_comma)),
																			Integer.parseInt(afterpos.substring(pos_comma+1)) );
			}

			if(beforepos.equals("effect_area_ll"))
			{	int pos_comma = afterpos.indexOf(",");
				triggers[current_trigger].effects[current_effect].area_ll = new POINT(Integer.parseInt(afterpos.substring(0,pos_comma)),
																			Integer.parseInt(afterpos.substring(pos_comma+1)) );
			}

			if(beforepos.equals("effect_area_ur"))
			{	int pos_comma = afterpos.indexOf(",");
				triggers[current_trigger].effects[current_effect].area_ur = new POINT(Integer.parseInt(afterpos.substring(0,pos_comma)),
																			Integer.parseInt(afterpos.substring(pos_comma+1)) );
			}

			//unit group constants
			if(beforepos.equals("effect_unit_group"))
			{	triggers[current_trigger].effects[current_effect].unit_group = Integer.parseInt(afterpos);
			}

			//building type constants
			if(beforepos.equals("effect_building_type"))
			{	triggers[current_trigger].effects[current_effect].building_type = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("effect_instruction_panel"))
			{	triggers[current_trigger].effects[current_effect].instruction_panel = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("effect_text"))
			{	triggers[current_trigger].effects[current_effect].text = afterpos;
				triggers[current_trigger].effects[current_effect].text_len = afterpos.length()+1;
			}

			if(beforepos.equals("effect_sound_file"))
			{	triggers[current_trigger].effects[current_effect].sound_file = afterpos;
				triggers[current_trigger].effects[current_effect].sound_len = afterpos.length()+1;
			}

			//unit id's
			if(beforepos.equals("effect_unit_ids"))
			{	//Keep reading ids till numselected
				int i=0;
				while(i<triggers[current_trigger].effects[current_effect].num_selected)
				{
					String newstr = br.readLine();current_line++;
					int newpos = newstr.indexOf(":");
					String newbefore = newstr.substring(0,newpos).trim().toLowerCase();
					String newafterpos = newstr.substring(newpos+1);
					if(newbefore.equals("id"))
					{	triggers[current_trigger].effects[current_effect].unit_ids[i]= Integer.parseInt(newafterpos);
						i++;
					}
				}
			}

			if(beforepos.equals("endeffect"))
			{	current_effect++;
			}

			//----------------------- End of effects ---------------------------------------------------------------

			//Conditions -------------------------------------------------------------------------------------------
			if(beforepos.equals("condition"))
			{	triggers[current_trigger].conditions[current_condition] = new Condition();
			}

			if(beforepos.equals("condition_type"))
			{	triggers[current_trigger].conditions[current_condition].stringtotype(afterpos);
			}

			if(beforepos.equals("condition_amount"))
			{	triggers[current_trigger].conditions[current_condition].amount = Integer.parseInt(afterpos);
			}

			//Resource constants
			if(beforepos.equals("condition_resource"))
			{	triggers[current_trigger].conditions[current_condition].resource = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("condition_unit_object"))
			{	triggers[current_trigger].conditions[current_condition].unit_object = Integer.parseInt(afterpos);
			}

			//check
			if(beforepos.equals("condition_unit_location"))
			{	triggers[current_trigger].conditions[current_condition].unit_location = Integer.parseInt(afterpos);
			}

			//unit type constants
			if(beforepos.equals("condition_unit_type"))
			{	triggers[current_trigger].conditions[current_condition].unit_type = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("condition_player"))
			{	triggers[current_trigger].conditions[current_condition].player = Integer.parseInt(afterpos);
			}

			//Technology constants
			if(beforepos.equals("condition_technology"))
			{	triggers[current_trigger].conditions[current_condition].technology = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("condition_timer"))
			{	triggers[current_trigger].conditions[current_condition].timer = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("condition_area_ll"))
			{	int pos_comma = afterpos.indexOf(",");
				triggers[current_trigger].conditions[current_condition].area_ll = new POINT(Integer.parseInt(afterpos.substring(0,pos_comma)),
																				 Integer.parseInt(afterpos.substring(pos_comma+1)) );
			}

			if(beforepos.equals("condition_area_ur"))
			{	int pos_comma = afterpos.indexOf(",");
				triggers[current_trigger].conditions[current_condition].area_ur = new POINT(Integer.parseInt(afterpos.substring(0,pos_comma)),
																				 Integer.parseInt(afterpos.substring(pos_comma+1)) );
			}

			//unit group constants
			if(beforepos.equals("condition_unit_group"))
			{	triggers[current_trigger].conditions[current_condition].unit_group = Integer.parseInt(afterpos);
			}

			//building type constants
			if(beforepos.equals("condition_building_type"))
			{	triggers[current_trigger].conditions[current_condition].building_type = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("condition_ai_signal"))
			{	triggers[current_trigger].conditions[current_condition].timer = Integer.parseInt(afterpos);
			}

			if(beforepos.equals("endcondition"))
			{	current_condition++;
			}
			//------------------------------------------  End of conditions -------------------------------------------
		}//End of while loop ( all triggers done )

		//Writing to a new file

		FileWriter fout = new FileWriter("../scripts\\debug.txt");
		for(int i=0;i<numtriggers;i++)
		{	fout.write("# -- Trigger"+(i+1)+"-- \r\n");
			triggers[i].writetoscript(fout);
		}
		fout.close();


		fr.close();
		//Writing triggers to scenario
		for(int i=0;i<numtriggers;i++)
			triggers[i].writetoscx(outfile);

		return numtriggers;
		}catch(Exception e){ System.out.println("Error reading trigger "+e); e.printStackTrace(); return 0;
		}
	}

	int getNumTriggers(String filename)
	{
		int num=0;
		try{
		FileReader fr = new FileReader(filename);
		BufferedReader br = new BufferedReader(fr);
		String s;
		while((s = br.readLine()) != null) {

		int pos=s.indexOf(":");
		String beforepos = "";
		if(pos!=-1)
			beforepos = s.substring(0,pos).trim().toLowerCase();

		if(beforepos.equals("trigger"))
			num++;
		}
		fr.close();
		}catch(Exception e){ System.out.println("Error reading scriptfile "+e); e.printStackTrace();
		}

		return num;
	}

	int getNumEffects(String filename, int startline)
	{
		int numeffects=0;
		try{
		FileReader fr = new FileReader(filename);
		BufferedReader br = new BufferedReader(fr);
		String s;

		for(int i=1;i<=startline;i++)
			br.readLine();

		while((s = br.readLine()) != null) {

		int pos=s.indexOf(":");
		String beforepos = "";
		if(pos!=-1)
			beforepos = s.substring(0,pos).trim().toLowerCase();

		if(beforepos.equals("effect"))
			numeffects++;
		if(beforepos.equals("endtrigger"))
			break;

		}
		fr.close();
		}catch(Exception e){ System.out.println("Error reading scriptfile "+e); e.printStackTrace();
		}

		return numeffects;
	}

	int getNumConditions(String filename, int startline)
	{
		int numeffects=0;
		try{
		FileReader fr = new FileReader(filename);
		BufferedReader br = new BufferedReader(fr);
		String s;

		for(int i=1;i<=startline;i++)
			br.readLine();

		while((s = br.readLine()) != null) {

		int pos=s.indexOf(":");
		String beforepos = "";
		if(pos!=-1)
			beforepos = s.substring(0,pos).trim().toLowerCase();

		if(beforepos.equals("condition"))
			numeffects++;
		if(beforepos.equals("endtrigger"))
			break;

		}
		fr.close();
		}catch(Exception e){ System.out.println("Error reading scriptfile "+e); e.printStackTrace();
		}

		return numeffects;
	}

}