import java.io.File;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.*;
import java.io.*;

//Class for parsing the xml script file and storing it as triggers
//uses the DOM parser
class scriptreader
{	static void read(String filename, String outfile)
	{	try{
		File file = new File(filename);
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		Document doc = db.parse(file);
		doc.getDocumentElement().normalize();
		System.out.println("Parsing "+filename);
		
		NodeList triggerlist = doc.getElementsByTagName("trigger");
		
		int numtriggers = triggerlist.getLength();
		
		System.out.println("Number of triggers: "+numtriggers);
		Trigger triggers[] = new Trigger[numtriggers];
		
		for(int i=0;i<numtriggers;i++)
		{	Node currentnode = triggerlist.item(i);
			triggers[i] = new Trigger();
			Element currenttrigger = (Element)currentnode;
			
			//Get more info from trigger
			NodeList ncur = currenttrigger.getElementsByTagName("enabled");
			Element nel;NodeList nfst;
			if(ncur.getLength()>0)
			{
			nel = (Element)ncur.item(0);
			nfst = nel.getChildNodes();
			if(nfst.item(0).getNodeValue().equals("true")) triggers[i].enabled = true;
			}
			
			ncur = currenttrigger.getElementsByTagName("looping");
			nel = (Element)ncur.item(0);
			nfst = nel.getChildNodes();
			if(nfst.item(0).getNodeValue().equals("true")) triggers[i].looping = true;
			
			ncur = currenttrigger.getElementsByTagName("objective");
			nel = (Element)ncur.item(0);
			nfst = nel.getChildNodes();
			if(nfst.item(0).getNodeValue().equals("true")) triggers[i].objective = true;
			
			ncur = currenttrigger.getElementsByTagName("desc_order");
			nel = (Element)ncur.item(0);
			nfst = nel.getChildNodes();
			triggers[i].desc_order = Integer.parseInt(nfst.item(0).getNodeValue());
			
			ncur = currenttrigger.getElementsByTagName("description");
			if(ncur.getLength()>0){
			nel = (Element)ncur.item(0);
			nfst = nel.getChildNodes();
			triggers[i].description = nfst.item(0).getNodeValue();
			triggers[i].desc_len = triggers[i].description.length()+1;
			}
			
			ncur = currenttrigger.getElementsByTagName("name");
			if(ncur.getLength()>0){
			nel = (Element)ncur.item(0);
			nfst = nel.getChildNodes();
			triggers[i].name = nfst.item(0).getNodeValue();
			triggers[i].name_len = triggers[i].name.length()+1;
			}
						
			NodeList effectlist = currenttrigger.getElementsByTagName("effect");			
			triggers[i].num_effects = effectlist.getLength();
			triggers[i].effects = new Effect[effectlist.getLength()];
			
			System.out.println("Trigger "+i+" has "+effectlist.getLength()+" effects");
			//Now read each of the effects
			
			//Remember to check for numeric as well as text effects
			
			for(int j=0;j<effectlist.getLength();j++)
			{	Node effectnode = effectlist.item(j);
				Element currenteffect = (Element)effectnode;
				triggers[i].effects[j] = new Effect();
				
				NodeList list = currenteffect.getElementsByTagName("type");
				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					String type = fst.item(0).getNodeValue();
					triggers[i].effects[j].stringtotype(type);
					
					System.out.println("type : "+type+" "+triggers[i].effects[j].type);
				}
				
				int check;	//always = 0x17. For internal use by AOK (and AOKTS).
				
				list = currenteffect.getElementsByTagName("ai_goal");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].ai_goal = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("amount");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].amount = Integer.parseInt(fst.item(0).getNodeValue());
				}
				//Resource constants
				list = currenteffect.getElementsByTagName("resource");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].resource = Integer.parseInt(fst.item(0).getNodeValue());
				}
				//Diplomacy constants
				list = currenteffect.getElementsByTagName("diplomacy");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].diplomacy = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("num_selected");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].num_selected = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("location_unit");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].location_unit = Integer.parseInt(fst.item(0).getNodeValue());
				}
				//Unit constants
				list = currenteffect.getElementsByTagName("unit_type");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].unit_type = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("player_source");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].player_source = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("player_target");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].player_target = Integer.parseInt(fst.item(0).getNodeValue());
				}
				//Tech constants
				list = currenteffect.getElementsByTagName("technology");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].technology = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("string_id");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].stringid = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("display_time");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].display_time = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("efftrigger");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].trigger = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("location");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					String loc = fst.item(0).getNodeValue();
					int pos = loc.indexOf(",");
					triggers[i].effects[j].location = new POINT(Integer.parseInt(loc.substring(0,pos)),
																Integer.parseInt(loc.substring(pos+1)) );
				}
				
				list = currenteffect.getElementsByTagName("area_ll");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					String loc = fst.item(0).getNodeValue();
					int pos = loc.indexOf(",");
					triggers[i].effects[j].area_ll = new POINT(Integer.parseInt(loc.substring(0,pos)),
																Integer.parseInt(loc.substring(pos+1)) );
				}
				
				list = currenteffect.getElementsByTagName("area_ur");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					String loc = fst.item(0).getNodeValue();
					int pos = loc.indexOf(",");
					triggers[i].effects[j].area_ur = new POINT(Integer.parseInt(loc.substring(0,pos)),
																Integer.parseInt(loc.substring(pos+1)) );
				}
	
				list = currenteffect.getElementsByTagName("unit_group");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].unit_group = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("building_type");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].building_type = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("instruction_panel");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].effects[j].instruction_panel = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currenteffect.getElementsByTagName("text");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					//Color problems here
					String textwithquotes = (fst.item(0).getNodeValue());
					textwithquotes = textwithquotes.replace('{','<');
					textwithquotes = textwithquotes.replace('}','>');
					triggers[i].effects[j].text = textwithquotes;
					triggers[i].effects[j].text_len = textwithquotes.length()+1;
				}
				
				list = currenteffect.getElementsByTagName("sound_file");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					String sf = "";
					try{
						sf = fst.item(0).getNodeValue();
					}catch(NullPointerException np){ sf = "";
					}
					triggers[i].effects[j].sound_file = sf;
					triggers[i].effects[j].sound_len = triggers[i].effects[j].sound_file.length()+1;
				}
				
				//unit id's
				if(triggers[i].effects[j].num_selected>0)
				{
					NodeList idlist = currenteffect.getElementsByTagName("id");
					triggers[i].effects[j].unit_ids = new int[triggers[i].effects[j].num_selected];
						
					for(int k=0;k<idlist.getLength();k++)
					{	Element el = (Element)idlist.item(k);
						NodeList fst = el.getChildNodes();
						triggers[i].effects[j].unit_ids[k] = Integer.parseInt(fst.item(0).getNodeValue());
					}		
					
					
				}				
				
			}//end of effects loop
			//Now for conditions
			NodeList conditionlist = currenttrigger.getElementsByTagName("condition");			
			triggers[i].num_conditions = conditionlist.getLength();
			triggers[i].conditions = new Condition[conditionlist.getLength()];
			
			System.out.println("Trigger "+i+" has "+conditionlist.getLength()+" conditions");
			//Now read each of the conditions
			for(int j=0;j<conditionlist.getLength();j++)
			{	Node conditionnode = conditionlist.item(j);
				Element currentcondition = (Element)conditionnode;
				triggers[i].conditions[j] = new Condition();
				
				NodeList list = currentcondition.getElementsByTagName("type");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					String type = fst.item(0).getNodeValue();
					triggers[i].conditions[j].stringtotype(type);
					
					//triggers[i].conditions[j].type = Integer.parseInt(fst.item(0).getNodeValue());
					System.out.println("type : "+type+" "+triggers[i].conditions[j].type);
				}
				
				list = currentcondition.getElementsByTagName("amount");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].conditions[j].amount = Integer.parseInt(fst.item(0).getNodeValue());
				}
				//Resource constants
				list = currentcondition.getElementsByTagName("resource");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].conditions[j].resource = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currentcondition.getElementsByTagName("unit_object");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].conditions[j].unit_object = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currentcondition.getElementsByTagName("unit_location");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].conditions[j].unit_location = Integer.parseInt(fst.item(0).getNodeValue());
				}
				//Unit constants
				list = currentcondition.getElementsByTagName("unit_type");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].conditions[j].unit_type = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currentcondition.getElementsByTagName("player");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].conditions[j].player = Integer.parseInt(fst.item(0).getNodeValue());
				}
				//Technology constants
				list = currentcondition.getElementsByTagName("technology");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].conditions[j].technology = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currentcondition.getElementsByTagName("timer");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].conditions[j].timer = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currentcondition.getElementsByTagName("area_ll");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					String loc = fst.item(0).getNodeValue();
					int pos = loc.indexOf(",");
					triggers[i].conditions[j].area_ll = new POINT(Integer.parseInt(loc.substring(0,pos)),
																Integer.parseInt(loc.substring(pos+1)) );
				}
				
				list = currentcondition.getElementsByTagName("area_ur");				
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					String loc = fst.item(0).getNodeValue();
					int pos = loc.indexOf(",");
					triggers[i].conditions[j].area_ur = new POINT(Integer.parseInt(loc.substring(0,pos)),
																Integer.parseInt(loc.substring(pos+1)) );
				}
				
				list = currentcondition.getElementsByTagName("unit_group");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].conditions[j].unit_group = Integer.parseInt(fst.item(0).getNodeValue());
				}
				//Type constants
				list = currentcondition.getElementsByTagName("building_type");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].conditions[j].building_type = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				list = currentcondition.getElementsByTagName("ai_signal");
				if(list.getLength()>0)
				{	Element el = (Element)list.item(0);
					NodeList fst = el.getChildNodes();
					triggers[i].conditions[j].ai_signal = Integer.parseInt(fst.item(0).getNodeValue());
				}
				
				
			}//End of conditions loop
			triggers[i].setorders();
			
			triggers[i].writetoscx(outfile);
		}//End of triggers loop
			
			
		}catch(Exception e){ System.out.println("Error reading trigger "+e); e.printStackTrace();
		}
	}
	public static void main(String arg[])
	{	read("script.xml","newscen.hex");
	}
}